#!/usr/bin/perl
# Registry v.3.0 
# written by: Dave Palmer <dave@upstatepress.com>
########################################################
# Registry is a simple guestbook. Yeah, just another   #
# guestbook. Nothing too special. You can remove un-   #
# wanted entries, and set up is pretty simple too.     #
# Registry is completely database driven, so admin-    #
# istration is all done through your browser.          #
########################################################
# This file requires no modifications                  #
########################################################
# (c) 1997 all rights reserved                         #
# you may use this program on any server.              #
# permission is granted to redistribute this program   #
# in any medium, assuming that this copyright statement#
# stay intact.                                         #
########################################################

# Get our configuration variables
require "reg-config.pl";

########################################################

&GetData;
&Translate;
&GetDate;
&WhatToDo;


sub GetData {
read(STDIN, $input, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/, $input);
		foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		
		$name =~ tr/+/ /;
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$FORM{$name} = $value;
			}
   	}
sub Translate {
$fullname = $FORM{'fullname'};
($fname, $lname) = split(/ /, $fullname);
$email = $FORM{'email'};
$url = $FORM{'url'};
$city = $FORM{'city'};
$state = $FORM{'state'};
$comments = $FORM{'comments'};
$action = $FORM{'action'};

if(! $fullname) {
	&Error("藍_AzgjW"); 		
			}
	if(! $email) {
		&Error("藍_AzgE-Mail");
				}
	if(! $comments) {
		&Error("藍_AzdOťժ");
					}
$comments =~ s/\cM//g;
$comments =~ s/\n/  /g;
	}
sub WhatToDo {
	if($action =~ /add/) {
		&AddEntry;
			}
		else { &Error("藍_Awʧ@"); }
if($notify eq "yes") {
	&Notify;
	    }
	if($thanks eq "yes") {
		&Thanks;
			}
	}
sub AddEntry {
open(NUMBERS, "$base_dir/id.txt") || &Error("藍_A䤣idɮ");
$number = <NUMBERS>;
	close(NUMBERS);
	++$number;
open(NUMBERS, ">$base_dir/id.txt") || &Error("no id file found");
	print NUMBERS "$number\n";
		close(NUMBERS);
open(DATA, ">>$base_dir/reg-data.txt") || &Error("no database found");
print DATA "$number=$fname&&$lname&&$email&&$url&&$city&&$state&&$comments&&$date\n";
	close(DATA);
print "Content-type: text/html\n\n";
print "<html><head><title>±z! $fname!</title>\n";
print "<body bgcolor=White vlink=Maroon link=Navy>\n";
print "<font size=+2>P $fname d!</font><p>\n";
print "<font size=3><a href=\"$base_url\">[ݱzd</a>\n";
print "</body></html>\n";
		}
sub GetDate {
	@days = ('P','P@','PG','PT','P|','P','P');
	@months = ('1','2','3','4','5','6','7','8','9',
			'10','11','12');
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
	if($hour < 10) { $hour = "0$hour"; }
	if ($min < 10) { $min = "0$min"; }
	if ($sec < 10) { $sec = "0$sec"; }

	$date = "19$year~$months[$mon]$mday$days[$wday]";
			}
sub Notify {
open(MAIL, "| $mailprog -t") || die;
print MAIL "To: $admin_name <$admin_email>\n";
print MAIL "From: $admin_email\n";
print MAIL "Subject: New entry\n";
print MAIL "$notify_message\n";
	close(MAIL);
		}
sub Thanks {
open(MAIL, "| $mailprog -t") || die;
print MAIL "To: $fullname <$email>\n";
print MAIL "From: $admin_name <$admin_email>\n";
print MAIL "Subject: Thanks!\n";
print MAIL "----HUOdï۰ʦ^----\n\n";
print MAIL "$thanks_message\n";
	close(MAIL);
		}
sub Error {
print "Content-type: text/html\n\n";
print "<html><head><title>~</title></head>\n";
print "<body bgcolor=White>\n";
print "<font size=+2><b>Sorry!</b></font><p>\n";
print "<font size=2>$_[0]</font></p>\n";
print "</body></html>\n";
exit;
		}
